/* event_handler.h
 *
 *  Copyright (C) 2006,2007 Tuomo Makinen (tjam@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef EVENT_HANDLER_H
#define EVENT_HANDLER_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "nuhe_global.h"
#include "slist.h"
#include "nuhed.h"

/* Event handler structure */
struct event
{
  char **event_id;
  char *alertsrc;
  char *ruledesc;

  unsigned int id_size;
  unsigned int event_cnt;
  unsigned int action_idx;
  
  /* -1 means that event is marked
   * to be deleted
   */
  int pending;
  time_t t_start;

  struct action *acell;
  struct rule *rcell;
};

void monitor_events (struct internal *vars);
int send_event (struct internal *vars, struct rule *rcell, char *alertsrc,
                char **event_id, int size);
int search_and_reset_event (struct internal *vars, char *entry);

#endif	/* EVENT_HANDLER_H */
