/* nuhed.h
 *
 * Copyright (C) 2006,2007 Tuomo Makinen (tjam@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef NUHED_H
#define NUHED_H

#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <sys/utsname.h>
#include <pthread.h>
#include "nuhe_global.h"
#include "slist.h"
#include "event_handler.h"
#include "ruleparser.h"
#include "d_array.h"
#ifdef NODEMGR_SUPPORT
#include "nuheclient.h"
#endif

unsigned int quit_flag;

void logwriter (const char *log_entry);
void send_alarm (const char *alarmstr);
char * generate_alarm (struct rule *matched, char *src, char *sensorname, char *data);
void process_alert_data (struct internal *vars, char *alertsrc, char *entry);
void match_pcre (pcre *re, char *entry, char **substr, int *rc);

#endif				/* NUHED_H */
